]> rtime.felk.cvut.cz Git - coffee/buildroot.git/blob - support/dependencies/dependencies.sh
infra: Introduce BR2_HOST_NEEDS_JAVA
[coffee/buildroot.git] / support / dependencies / dependencies.sh
1 #!/bin/sh
2 # vi: set sw=4 ts=4:
3
4 export LC_ALL=C
5
6 # Verify that grep works
7 echo "WORKS" | grep "WORKS" >/dev/null 2>&1
8 if test $? != 0 ; then
9         echo
10         echo "grep doesn't work"
11         exit 1
12 fi
13
14 # sanity check for CWD in LD_LIBRARY_PATH
15 # try not to rely on egrep..
16 if test -n "$LD_LIBRARY_PATH" ; then
17         echo TRiGGER_start"$LD_LIBRARY_PATH"TRiGGER_end | grep ':\.:' >/dev/null 2>&1 ||
18         echo TRiGGER_start"$LD_LIBRARY_PATH"TRiGGER_end | grep 'TRiGGER_start\.:' >/dev/null 2>&1 ||
19         echo TRiGGER_start"$LD_LIBRARY_PATH"TRiGGER_end | grep ':\.TRiGGER_end' >/dev/null 2>&1 ||
20         echo TRiGGER_start"$LD_LIBRARY_PATH"TRiGGER_end | grep 'TRiGGER_start\.TRiGGER_end' >/dev/null 2>&1
21         if test $? = 0; then
22                 echo
23                 echo "You seem to have the current working directory in your"
24                 echo "LD_LIBRARY_PATH environment variable. This doesn't work."
25                 exit 1;
26         fi
27 fi;
28
29 # sanity check for CWD in PATH. Having the current working directory
30 # in the PATH makes the toolchain build process break.
31 # try not to rely on egrep..
32 if test -n "$PATH" ; then
33         echo TRiGGER_start"$PATH"TRiGGER_end | grep ':\.:' >/dev/null 2>&1 ||
34         echo TRiGGER_start"$PATH"TRiGGER_end | grep 'TRiGGER_start\.:' >/dev/null 2>&1 ||
35         echo TRiGGER_start"$PATH"TRiGGER_end | grep ':\.TRiGGER_end' >/dev/null 2>&1 ||
36         echo TRiGGER_start"$PATH"TRiGGER_end | grep 'TRiGGER_start\.TRiGGER_end' >/dev/null 2>&1
37         if test $? = 0; then
38                 echo
39                 echo "You seem to have the current working directory in your"
40                 echo "PATH environment variable. This doesn't work."
41                 exit 1;
42         fi
43 fi;
44
45 if test -n "$PERL_MM_OPT" ; then
46         echo
47         echo "You have PERL_MM_OPT defined because Perl local::lib"
48         echo "is installed on your system. Please unset this variable"
49         echo "before starting Buildroot, otherwise the compilation of"
50         echo "Perl related packages will fail"
51         exit 1
52 fi
53
54 # Verify that which is installed
55 if ! which which > /dev/null ; then
56         echo
57         echo "You must install 'which' on your build machine";
58         exit 1;
59 fi;
60
61 if ! which sed > /dev/null ; then
62         echo
63         echo "You must install 'sed' on your build machine"
64         exit 1
65 fi
66
67 # Check make
68 MAKE=$(which make 2> /dev/null)
69 if [ -z "$MAKE" ] ; then
70         echo
71         echo "You must install 'make' on your build machine";
72         exit 1;
73 fi;
74 MAKE_VERSION=$($MAKE --version 2>&1 | sed -e 's/^.* \([0-9\.]\)/\1/g' -e 's/[-\ ].*//g' -e '1q')
75 if [ -z "$MAKE_VERSION" ] ; then
76         echo
77         echo "You must install 'make' on your build machine";
78         exit 1;
79 fi;
80 MAKE_MAJOR=$(echo $MAKE_VERSION | sed -e "s/\..*//g")
81 MAKE_MINOR=$(echo $MAKE_VERSION | sed -e "s/^$MAKE_MAJOR\.//g" -e "s/\..*//g" -e "s/[a-zA-Z].*//g")
82 if [ $MAKE_MAJOR -lt 3 ] || [ $MAKE_MAJOR -eq 3 -a $MAKE_MINOR -lt 81 ] ; then
83         echo
84         echo "You have make '$MAKE_VERSION' installed.  GNU make >=3.81 is required"
85         exit 1;
86 fi;
87
88 # Check host gcc
89 COMPILER=$(which $HOSTCC_NOCCACHE 2> /dev/null)
90 if [ -z "$COMPILER" ] ; then
91         COMPILER=$(which cc 2> /dev/null)
92 fi;
93 if [ -z "$COMPILER" ] ; then
94         echo
95         echo "You must install 'gcc' on your build machine";
96         exit 1;
97 fi;
98
99 COMPILER_VERSION=$($COMPILER -v 2>&1 | sed -n '/^gcc version/p' |
100         sed -e 's/^gcc version \([0-9\.]\)/\1/g' -e 's/[-\ ].*//g' -e '1q')
101 if [ -z "$COMPILER_VERSION" ] ; then
102         echo
103         echo "You must install 'gcc' on your build machine";
104         exit 1;
105 fi;
106 COMPILER_MAJOR=$(echo $COMPILER_VERSION | sed -e "s/\..*//g")
107 COMPILER_MINOR=$(echo $COMPILER_VERSION | sed -e "s/^$COMPILER_MAJOR\.//g" -e "s/\..*//g")
108 if [ $COMPILER_MAJOR -lt 3 -o $COMPILER_MAJOR -eq 2 -a $COMPILER_MINOR -lt 95 ] ; then
109         echo
110         echo "You have gcc '$COMPILER_VERSION' installed.  gcc >= 2.95 is required"
111         exit 1;
112 fi;
113
114 # check for host CXX
115 CXXCOMPILER=$(which $HOSTCXX_NOCCACHE 2> /dev/null)
116 if [ -z "$CXXCOMPILER" ] ; then
117         CXXCOMPILER=$(which c++ 2> /dev/null)
118 fi
119
120 if [ -z "$CXXCOMPILER" ] ; then
121         echo
122         echo "You may have to install 'g++' on your build machine"
123 fi
124 if [ ! -z "$CXXCOMPILER" ] ; then
125         CXXCOMPILER_VERSION=$($CXXCOMPILER -v 2>&1 | sed -n '/^gcc version/p' |
126                 sed -e 's/^gcc version \([0-9\.]\)/\1/g' -e 's/[-\ ].*//g' -e '1q')
127         if [ -z "$CXXCOMPILER_VERSION" ] ; then
128                 echo
129                 echo "You may have to install 'g++' on your build machine"
130         fi
131
132         CXXCOMPILER_MAJOR=$(echo $CXXCOMPILER_VERSION | sed -e "s/\..*//g")
133         CXXCOMPILER_MINOR=$(echo $CXXCOMPILER_VERSION | sed -e "s/^$CXXCOMPILER_MAJOR\.//g" -e "s/\..*//g")
134         if [ $CXXCOMPILER_MAJOR -lt 3 -o $CXXCOMPILER_MAJOR -eq 2 -a $CXXCOMPILER_MINOR -lt 95 ] ; then
135                 echo
136                 echo "You have g++ '$CXXCOMPILER_VERSION' installed.  g++ >= 2.95 is required"
137                 exit 1
138         fi
139 fi
140
141 # Check bash
142 if ! $SHELL --version 2>&1 | grep -q '^GNU bash'; then
143         echo
144         echo "You must install 'bash' on your build machine";
145         exit 1;
146 fi;
147
148 # Check that a few mandatory programs are installed
149 missing_progs="no"
150 for prog in patch perl tar wget cpio python unzip rsync bc ${DL_TOOLS} ; do
151         if ! which $prog > /dev/null ; then
152                 echo "You must install '$prog' on your build machine";
153                 missing_progs="yes"
154                 if test $prog = "svn" ; then
155                         echo "  svn is usually part of the subversion package in your distribution"
156                 elif test $prog = "hg" ; then
157                         echo "  hg is usually part of the mercurial package in your distribution"
158                 elif test $prog = "zcat" ; then
159                         echo "  zcat is usually part of the gzip package in your distribution"
160                 elif test $prog = "bzcat" ; then
161                         echo "  bzcat is usually part of the bzip2 package in your distribution"
162                 fi
163         fi
164 done
165
166 if test "${missing_progs}" = "yes" ; then
167         exit 1
168 fi
169
170 if grep ^BR2_TOOLCHAIN_BUILDROOT=y $BR2_CONFIG > /dev/null && \
171         grep ^BR2_ENABLE_LOCALE=y       $BR2_CONFIG > /dev/null ; then
172         if ! which locale > /dev/null ; then
173                 echo
174                 echo "You need locale support on your build machine to build a toolchain supporting locales"
175                 exit 1 ;
176         fi
177         if ! locale -a | grep -q -i utf8$ ; then
178                 echo
179                 echo "You need at least one UTF8 locale to build a toolchain supporting locales"
180                 exit 1 ;
181         fi
182 fi
183
184 if grep -q ^BR2_PACKAGE_CLASSPATH=y $BR2_CONFIG ; then
185         for prog in javac jar; do
186                 if ! which $prog > /dev/null ; then
187                         echo >&2
188                         echo "You must install '$prog' on your build machine" >&2
189                         exit 1
190                 fi
191         done
192 fi
193
194 if grep -q ^BR2_HOST_NEEDS_JAVA=y $BR2_CONFIG ; then
195         if ! which java > /dev/null ; then
196                 echo >&2
197                 echo "You must install 'java' on your build machine" >&2
198                 exit 1
199         fi
200 fi
201
202 if grep -q ^BR2_HOSTARCH_NEEDS_IA32_LIBS=y $BR2_CONFIG ; then
203         if test ! -f /lib/ld-linux.so.2 ; then
204                 echo
205                 echo "Your Buildroot configuration uses pre-built tools for the x86 architecture,"
206                 echo "but your build machine uses the x86-64 architecture without the 32 bits compatibility"
207                 echo "library."
208                 echo "If you're running a Debian/Ubuntu distribution, install the libc6:i386,"
209                 echo "libstdc++6:i386, and zlib1g:i386 packages."
210                 echo "For other distributions, refer to the documentation on how to install the 32 bits"
211                 echo "compatibility libraries."
212                 exit 1
213         fi
214 fi
215
216 if grep -q ^BR2_HOSTARCH_NEEDS_IA32_COMPILER=y $BR2_CONFIG ; then
217         if ! echo "int main(void) {}" | gcc -m32 -x c - -o /dev/null ; then
218                 echo
219                 echo "Your Buildroot configuration needs a compiler capable of building 32 bits binaries."
220                 echo "If you're running a Debian/Ubuntu distribution, install the gcc-multilib package."
221                 echo "For other distributions, refer to their documentation."
222                 exit 1
223         fi
224 fi
225
226 # Check that the Perl installation is complete enough to build
227 # host-autoconf.
228 if ! perl  -e "require Data::Dumper" > /dev/null 2>&1 ; then
229         echo "Your Perl installation is not complete enough, at least Data::Dumper is missing."
230         echo "On Debian/Ubuntu distributions, install the 'perl' package."
231         exit 1
232 fi